package nxm.dsp.prim;

import nxm.sys.inc.*;
import nxm.sys.lib.*;

/**
  Creates FFT windows of various shapes.

  @author Jeff Schoen
  @version $Id: window.java,v 1.3 2012/03/09 14:49:29 jgs Exp $

*/
public class window extends Primitive {

  public int open() {

    // Get parameters
    String name = MA.getS("NAME");
    int    size = MA.getL("SIZE");
    boolean sym = MA.getState("/SYM");
    double scale = MA.getD("/SCALE",1.0);

    // Create window
    Data data = DataOp.getWindow(name,sym?-size:size,scale,M);

    // Open output file
    DataFile hcb = MA.getDataFile("OUT","1000","SF",0); 
    hcb.setSize (size);
    hcb.open();
    hcb.write (data);
    hcb.close();

    return (FINISH);
  }

}
