package nxm.sys.inc;

import nxm.sys.lib.Midas;

/** Definition of the MidasReference interface to obtain a Midas Context (e.g. for file I/O). <br>
    The classes that implement this interface in <b>SYS</b> are Args, Command, Midas, NeXtMidas, and Shell.

    @author Adam Weisz / Neon Ngo / J. Czechowski IV
    @see nxm.sys.lib.Args
    @see nxm.sys.lib.Command
    @see nxm.sys.lib.Midas
    @see nxm.sys.lib.NeXtMidas
    @see nxm.sys.lib.Shell
    @since NeXtMidas 3.5.0
    @version $Id: MidasReference.java,v 1.5 2014/08/05 20:28:19 ntn Exp $
 */
public interface MidasReference {

  /** Gets the current Midas context if it is available, otherwise, returns null.
      @return Midas Context if available, otherwise, null.
   */
  Midas getMidas();
}
