package nxm.sys.libm;

import nxm.sys.inc.Constants;

/**
   Performs the VDemux operation on arrays. <br>
   See {@link Operator} for a description of the available I/O Modes.
   @author  Auto-Generated
   @see     Operator
*/
@SuppressWarnings("cast")
public final class VDemux extends Operator implements Constants {

  /** Create a new instance. */
  public VDemux() {
    super();
  }

  /** Create a new instance.
      @param flags The processing flags to use.
   */
  public VDemux (int flags) {
    super(flags);
  }

  /** Create a new instance.
      @param scale The scale factor to use.
   */
  public VDemux (double scale) {
    super(scale);
  }

  /** Create a new instance.
      @param flags The processing flags to use.
      @param scale The scale factor to use.
   */
  public VDemux (int flags, double scale) {
    super(flags,scale);
  }

  public final int validate (char type, int n, int mode) {
    switch (mode) {
      case VSSS: return n;
      default: return NOSUPPORT;
    }
  }

  public final int process (double[][] v, int n, int mode) {
    switch (mode) {
      case VSSS: VSSS(v[0],v[1],v[2],v[3],n); return n;
      default:  return NOSUPPORT;
    }
  }

  public final int process (double[][] v, int n, int mode, double scale) {
    switch (mode) {
      case VSSS: VSSS(v[0],v[1],v[2],v[3],n); return n;
      default:  return NOSUPPORT;
    }
  }

  /** Apply this operator to mode {@link Operator#VSSS} data.
      @param a     The first  operand.
      @param b     The second  operand.
      @param c     The third  operand.
      @param d     The fourth  operand.
      @param n     The number of elements to operate on.
      @see #process(double[][],int,int)
   */
  public static final void VSSS (double[] a, double[] b, double[] c, double[] d, int n) {
      for (int i=0,k=0; i<n; i++,k+=3) {
        b[i]=a[k]; c[i]=a[k+1]; d[i]=a[k+2];
      }
  }

  public final int process (float[][] v, int n, int mode) {
    switch (mode) {
      case VSSS: VSSS(v[0],v[1],v[2],v[3],n); return n;
      default:  return NOSUPPORT;
    }
  }

  public final int process (float[][] v, int n, int mode, double scale) {
    switch (mode) {
      case VSSS: VSSS(v[0],v[1],v[2],v[3],n); return n;
      default:  return NOSUPPORT;
    }
  }

  /** Apply this operator to mode {@link Operator#VSSS} data.
      @param a     The first  operand.
      @param b     The second  operand.
      @param c     The third  operand.
      @param d     The fourth  operand.
      @param n     The number of elements to operate on.
      @see #process(float[][],int,int)
   */
  public static final void VSSS (float[] a, float[] b, float[] c, float[] d, int n) {
      for (int i=0,k=0; i<n; i++,k+=3) {
        b[i]=a[k]; c[i]=a[k+1]; d[i]=a[k+2];
      }
  }

  public final int process (int[][] v, int n, int mode) {
    switch (mode) {
      case VSSS: VSSS(v[0],v[1],v[2],v[3],n); return n;
      default:  return NOSUPPORT;
    }
  }

  public final int process (int[][] v, int n, int mode, double scale) {
    switch (mode) {
      case VSSS: VSSS(v[0],v[1],v[2],v[3],n); return n;
      default:  return NOSUPPORT;
    }
  }

  /** Apply this operator to mode {@link Operator#VSSS} data.
      @param a     The first  operand.
      @param b     The second  operand.
      @param c     The third  operand.
      @param d     The fourth  operand.
      @param n     The number of elements to operate on.
      @see #process(int[][],int,int)
   */
  public static final void VSSS (int[] a, int[] b, int[] c, int[] d, int n) {
      for (int i=0,k=0; i<n; i++,k+=3) {
        b[i]=a[k]; c[i]=a[k+1]; d[i]=a[k+2];
      }
  }

  public int getInputs() { return 1; }
  public int getOutputs() { return 3; }
}
