c************
c  Description: Defines useful run-time constants
c
c  Author:	JGS 4/2/90
c
c  $Revision: 1.1 $
c  $Modtime:   06 Jun 1994  9:55:16  $
c  
c************
c
c Mathematically interesting constants
	real*4 e,pi,halfpi,twopi
	parameter (e=2.718281828)
	parameter (pi=3.141592654)
	parameter (halfpi=1.570796327)
	parameter (twopi=6.283185308)
	real*8 de,dpi,dhalfpi,dtwopi
	parameter (de=2.718281828459045)
	parameter (dpi=3.141592653589793238462643)
	parameter (dhalfpi=1.570796326794896619231322)
	parameter (dtwopi=6.283185307179586476925287)
c
c Standard trigonometric windows
	character*46 standard_windows
	parameter (standard_windows=
     &		'NONE,BART,HANN,HAMM,BLACK,BH61,BH67,BH74,BH92,')
c
c Radial conversion factors
	real*4 rad2deg,deg2rad
	parameter (rad2deg=57.295779513)
	parameter (deg2rad=1.745329252E-02)
	real*8 drad2deg,ddeg2rad
	parameter (drad2deg=57.295779513082320876798155)
	parameter (ddeg2rad=1.7453292519943295769237D-02)
c
c Distance conversion factors (nm = nautical miles, sm = statute miles)
	real*8 feet2meters,nm2meters,nm2feet,sm2meters,sm2feet                 
	parameter (feet2meters=0.3048)	! Exact by international agreement
	parameter (nm2meters=1852.0) 	! Exact by international agreement
	parameter (nm2feet=6076.11548556)
	parameter (sm2meters=1609.344)	! Exact by international agreement
	parameter (sm2feet=5280.0)	! Exact by international agreement
c
c Constants associated with System Simulator package
c
c     Source: WGS 84 (Dept. of Defense World Geodetic Survey 1984 - Its
c                     Definition and Relationships with local Geodetic Systems)
c             Defense Mapping Agency, Building 56, U.S. Naval Observatory
c             Washington DC 20305-3000
c
	real*8	earth_eccentricity,earth_equatorial_radius,
     &		earth_angular_velocity,angular_velocity_precessing_cor,
     &		def_earth_angular_velocity,iau_earth_angular_velocity,
     &		earth_flattening_factor,polar_radius_in_meters, 
     &		polar_radius_of_curvature,mass_of_earth_w_atmos,
     &		earth_grav_constant_w_atmos,earth_grav_constant_wo_atmos,  
     &		speed_of_light               

	parameter (earth_eccentricity=0.0818191908426)
	parameter (earth_equatorial_radius=6378137.0)       !in meters
	parameter (earth_angular_velocity=7292115.8553D-11) !rad per mean solar sec
	parameter (angular_velocity_precessing_cor=4.3D-15) !correction for above
	!  correction is multiplied by # of Julian centuries from Epoch J2000
	parameter (def_earth_angular_velocity=7292115d-11)	!+- .15d-11
	parameter (iau_earth_angular_velocity=7292115.1467d-11)
c
	parameter (earth_flattening_factor=.00335281066474) !1/298.257223563
	parameter (polar_radius_in_meters=6356752.3142)
	parameter (polar_radius_of_curvature=6399593.6258)
	parameter (mass_of_earth_w_atmos=5.9733328d+24)
	parameter (earth_grav_constant_w_atmos=3986005d+08)	!+- .6
	parameter (earth_grav_constant_wo_atmos=3986001.5d+08)	!+- .6
c
	parameter (speed_of_light=299792458)       !+- 1.2 m/sec
c
