#!/bin/bash
#####################EXPERIMENTAL PURPOSES ONLY#####################
#                                                                  #
# This script is the master script used for full preparation for a #
# NeXtMidas no-graphical build                                     #
#                                                                  #
# Environment Variables:                                           #
#   NMROOT - Current NeXtMidas distribution                        #
#                                                                  #
# Author: Zachary Matthews                                         #
# Since:  NeXtMidas 4.0.0                                          #
#                                                                  #
####################################################################

# Must have NMROOT defined
if [ -z "${NMROOT}" ] ; then
  echo "NMROOT is not set, can not swap, move, nor thin within NeXtMidas"
  exit 1
fi

# Move intr.Unittest.java into test.junit
if [ ! -f $NMROOT/nxm/sys/test/junit/Unittest.java ] ; then
  sh $NMROOT/swap/unittest/unittest_move.sh
  echo "Done moving Unittest.java"
else
  echo "nxm.sys.test.junit.Unittest.java already exists, no unittest swapping needed"
fi

# Move nxm.sys.dat into nxm.sys.test.dat
if [ ! -d $NMROOT/nxm/sys/test/dat ] ; then
  sh $NMROOT/swap/datNXM/dat_move.sh
  echo "Done moving nxm/sys/dat"
else
  echo "nxm/sys/test/dat already exists, no dat swapping needed"
fi

# Call the thin script to trim down NeXtMidas in preparation for a no-graphical build
sh $NMROOT/swap/thinNXM/thin_nextmidas.sh
